//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

const int max_pop=20; //maxymalna licznosc populacji
const int max_gen=20; //maxymalna dlugosc genomu
static int wejsc=0;  //ile razy odpalono main
int pop=1; //zmienna pop iteruje kolejne populacje
unsigned long int ilu_osobnikow=0; //ilu bylo ilu_osobnikowow

struct osobnik {
  char chromosom[21]; //max_gen+\0  =20+1
  int  sila; //chromosom funkcji dopasowania
  unsigned long int  cargo; //dodatkowe numer genu
  int rodzic; //ile razy byl rodzicem
};

struct wspolrzedne {  //pomocnicze przy selekcji
  int w;
  int k;
};

TFormGenetyk *FormGenetyk;
//---------------------------------------------------------------------------
__fastcall TFormGenetyk::TFormGenetyk(TComponent* Owner)
        : TForm(Owner)
  {
  }
void gen_populacji_start(struct osobnik *ptr_P, int max);
int funkcja_dopasowania(char *ptr_s,int chr );
void ocena_populacji(struct osobnik *ptr_P,int gen, int chr );
int mutacja(struct osobnik *ptr_P, float pm, int gen, int chr );
void krzyzowanie(struct osobnik *ptr_rodzice,struct osobnik *ptr_dzieci, float pk, int punkty);
bool warunek_konca(struct osobnik *ptr_P);
struct osobnik selekcja(struct osobnik *ptr_P);
void wybor_populacji(struct osobnik *ptr_P,struct osobnik *ptr_C,int ile);
void nowa_populacja(struct osobnik *ptr_new,struct osobnik *ptr_P,struct osobnik *ptr_C);
String i2s(int i);
int ile_blizniakow(struct osobnik *ptr_P);
void pokaz_populacje(struct osobnik *ptr_P,int ile);
int na_tego_bec(struct wspolrzedne *ptr_wsp, float czestosc, int gen, int chr);



//================================================================
void gen_populacji_start(struct osobnik *ptr_P, int max)
//generuje populacje startowa
{
 char literka[2];
            //12345678901234567890
 char *blank="abcdefghijklmnoprstu";
 char tmp_dna[21];
 int ile=0;

 randomize();

  for(int i=0;i< max ;i++)
  {//i
   strcpy(ptr_P[i].chromosom,blank); //clear profilaktycznie
   ptr_P[i].sila=0;
   ptr_P[i].rodzic=0;
   ptr_P[i].cargo= ++ilu_osobnikow;
   ile=0;
   strcpy(tmp_dna,"");

   for(int j=0;j< max_gen ;j++)
   {//j
        if (random(100)<=50)
                strcpy(literka,"0");
        else {
                strcpy(literka,"1");
                ile++;
              }
        strcat(tmp_dna, literka);
   }//j
   strcpy(ptr_P[i].chromosom,tmp_dna);
   ptr_P[i].sila=ile; 

    }//i
 }
//---------------------------------------------------------------------------
int funkcja_dopasowania(char *ptr_s,int chr )
//podaje wynik f.dopasowania dla chromosomu
{
  int k;
   int ile=0;
        for(k=0;k<chr;k++)
            {
             if (ptr_s[k]=='1')
              {
                 ile++;
               }
            }//k

 return(ile);
}
//---------------------------------------------------------------------------
void ocena_populacji(struct osobnik *ptr_P,int gen, int chr )
//wpisuje chromosom f. dopasowania do atrybutu sila
{
  int w;

   for(w=0;w<gen;w++)
    {
       ptr_P[w].sila=funkcja_dopasowania(ptr_P[w].chromosom,chr);
    }//w
}
//---------------------------------------------------------------------------
int mutacja(struct osobnik *ptr_P, float pm, int gen, int chr )
//dokonuje lub nie mutacji osobniku
{
   int ile=0,w,k;
   struct wspolrzedne wsp[max_pop];

   ile= na_tego_bec(wsp, pm, gen, chr);

   for(int i=0;i<ile;i++)
   {
     w=wsp[i].w;
     k=wsp[i].k;
     if(k>max_gen) k=max_gen;//to sie nie powinno zdarzac ;-)
     if (ptr_P[w].chromosom[k]=='1')
      {
         ptr_P[w].chromosom[k]='0';
         ptr_P[w].sila=ptr_P[w].sila-1;
       }
       else if (ptr_P[w].chromosom[k]=='0')
              {
                 ptr_P[w].chromosom[k]='1';
                 ptr_P[w].sila=ptr_P[w].sila+1;
              }
   }
   return(ile);
}
//---------------------------------------------------------------------------
int comp(const void *x, const void *y)
//pomocnicza do qsort'u w krzyzowaniu dziala dla int'ow
{
 int xx=*(int*)x;
 int yy=*(int*)y; //konwersja void->int

 if(xx < yy) return -1; //<0
 if(xx == yy)
    return 0;   //  =0
 else
    return 1;   //>0
}

int comp_sila(const void *x, const void *y)
//pomocnicza do qsort'u w selekcji dziala dla "struct osobnik"
{
 struct osobnik tmpX,tmpY;
 tmpX=*(struct osobnik*)x;
 tmpY=*(struct osobnik*)y; //konwersja "struct osobnik"

 int xx= tmpX.sila;
 int yy= tmpY.sila;

 if(xx < yy) return -1; //<0
 if(xx == yy)
    return 0;   //  =0
 else
    return 1;   //>0
}
//---------------------------------------------------------------------------
void krzyzowanie(struct osobnik *ptr_rodzice,struct osobnik *ptr_dzieci, float pk, int punkty)
//dokonuje krzyzownai rodzicow i wynikiem jest dwoje dzieci
{
 int t_pk[max_gen]; //tablica punktow krzyzowania
 char child0[21]="", child1[21]="";
 int offset=2; //miejsce na min i max czyli 0 i 20 w t_pk
 //zeby wypadly poza obszar sortu
 for(int i=0; i<max_gen;i++) t_pk[i]=max_gen*max_gen;
 t_pk[0]=0; //bo latwiej w petli co robi krzyzowanie
 t_pk[1]=max_gen;

 for(int i=offset;i<punkty+offset;i++)
 {
   t_pk[i]=random(max_gen);

   for(int j=0;j<i;j++)  //zapewnienie unikalnosci punktow krzyzowania
      {
       if (t_pk[j]==t_pk[i])
           i--; //wymusi, ze jeszcze raz wylosuje ten punkt
      }
 }

 //     tab, ilosc_elem, rozmiar elem., f.porownujaca
 qsort(t_pk,punkty+offset, sizeof(int),comp);

 for(int i=1;i<punkty+offset;i++)
 {
  div_t parz;
  parz= div(i,2);
  String s_temp;

  if(parz.rem==0) //parzysty
   {
        FormGenetyk->Edit->Text= ptr_rodzice[0].chromosom;
        s_temp=FormGenetyk->Edit->Text.SubString(t_pk[i-1],t_pk[i]-t_pk[i-1]);
        strcat(child1,s_temp.c_str());

        FormGenetyk->Edit->Text= ptr_rodzice[1].chromosom;
        s_temp=FormGenetyk->Edit->Text.SubString(t_pk[i-1],t_pk[i]-t_pk[i-1]);
        strcat(child0,s_temp.c_str());
   }
   else
   {
        FormGenetyk->Edit->Text= ptr_rodzice[0].chromosom;
        s_temp=FormGenetyk->Edit->Text.SubString(t_pk[i-1],t_pk[i]-t_pk[i-1]);
        strcat(child0,s_temp.c_str());

        FormGenetyk->Edit->Text= ptr_rodzice[1].chromosom;
        s_temp=FormGenetyk->Edit->Text.SubString(t_pk[i-1],t_pk[i]-t_pk[i-1]);
        strcat(child1,s_temp.c_str());
   }
  }//for

  strcpy(ptr_dzieci[0].chromosom, child0);
  strcpy(ptr_dzieci[1].chromosom, child1);
  //numer genu
  ptr_dzieci[0].cargo= ++ilu_osobnikow;
  ptr_dzieci[1].cargo= ++ilu_osobnikow;
  //inicjacja ile razy byl rodzicem
  ptr_dzieci[0].rodzic=0;
  ptr_dzieci[1].rodzic=0;
}

//---------------------------------------------------------------------------
bool warunek_konca(struct osobnik *ptr_P)
//zwarca chromosom konca gdy jest oczekiwany ilu_osobnikow
{
  bool wynik=true;

  for(int i=0; i<max_pop;i++)
  {
    if(ptr_P[i].sila==max_gen)
    {
        wynik=false;
        FormGenetyk->Memo->Lines->Insert(0," <<< Warunek koca osignity m.in. w chromosomie nr "+i2s(i)+" >>>");
     }
  }

  if (pop>10000)   //bylo 1000
   {
         wynik=false; //??? awaryjnie jakby cos sie mocno wloklo
         FormGenetyk->Memo->Lines->Insert(0," <<< Zbyt wiele populacji >>>");
   }

  if(wynik==false)
        FormGenetyk->Memo->Lines->Insert(0," >>> K O N I E C <<< ");

  return(wynik);
}
//---------------------------------------------------------------------------
struct osobnik selekcja(struct osobnik *ptr_P)
//selekcjonuje ilu_osobnikowa
{
  struct osobnik wynik;
  int suma=0; //wyniki f. dopasowania
  int traf;
  // clear jakby sie nie udalo
   strcpy(wynik.chromosom,"cogito ergo sum");
   wynik.sila=997;
   wynik.cargo=997;
   wynik.rodzic=997;

  //randomize();
  for(int i=0;i<max_pop;i++)
  {
    suma=suma+ ptr_P[i].sila;
  }

  suma=suma*100;

  //     tab, ilosc_elem, rozmiar elem., f.porownujaca
  qsort(ptr_P,max_pop, sizeof(struct osobnik),comp_sila);

  traf =random(suma);
  suma=0;
  int i;
  for(i=0;i<max_pop;i++)
  {
    suma=suma+ptr_P[i].sila;
    if(traf<=suma*100) //trafiles w szukany przedzial
     {
        ptr_P[i].rodzic++;
        wynik= ptr_P[i];
        break;
     }
  }


  return(wynik);
}
//---------------------------------------------------------------------------
String i2s(int i)
// pomocnicza zamienia liczbe jednocyfrowa X na postac 0X
{
  String wynik=i;
  if (i<=9)
  wynik="0"+wynik;

  return(wynik);
 }

String uli2s(unsigned long int i)
// pomocnicza zamienia liczbe jednocyfrowa X na postac 0X
{
  String wynik=i;
  if (i<=9)
  wynik="0"+wynik;

  return(wynik);
 }
//---------------------------------------------------------------------------
int ile_blizniakow(struct osobnik *ptr_P)
// zwraca ile jest takich samych chromosomow
//TO ZLE liczy ale co tam i tak uzywane testowo
{
  int wynik=0;
  struct osobnik tmp_P[max_pop];

  for(int i=0;i< max_pop ;i++)
   {
     tmp_P[i]=ptr_P[i];
     tmp_P[i].rodzic=0;
   }

  for(int j=0;j< max_pop ;j++)
   for(int i=0;i< max_pop ;i++)
    {
      if(strcmp(ptr_P[i].chromosom,tmp_P[j].chromosom)==0 &&
         ptr_P[i].cargo!=tmp_P[j].cargo)
       {
         tmp_P[j].rodzic++;
       }
    }

   for(int j=0;j< max_pop ;j++)
    {
      wynik=wynik+tmp_P[j].rodzic;
    }

  return(wynik);
}
//---------------------------------------------------------------------------
void pokaz_populacje(struct osobnik *ptr_P, int ile)
//pokazuje populacje
{
 if (ile==0) ile=max_pop; //domyslenie 0 wiec max_poulacja
 //FormGenetyk->Memo->Clear();  powinien dopisac

 for(int i=0;i< ile ;i++)
  {//i
   FormGenetyk->Edit->Text=ptr_P[i].chromosom;
   FormGenetyk->Edit->Text= i2s(i) +".)    "+ FormGenetyk->Edit->Text+ "    | "+ i2s(ptr_P[i].sila) +"    | "+ uli2s(ptr_P[i].cargo)+ "    | "; //+ i2s(ptr_P[i].rodzic);
   FormGenetyk->Memo->Lines->Insert(i,FormGenetyk->Edit->Text);
  }//i

   FormGenetyk->Memo->Lines->Insert(0,"To jest populacja numer: "+ i2s(pop));
   FormGenetyk->Memo->Lines->Insert(1,"------------------------------------------------------------------------------");
   FormGenetyk->Memo->Lines->Insert(1,"Nr.|               Chromosom               |  f(x)  |Nr. osob|");
   FormGenetyk->Memo->Lines->Insert(0,"");
}
//---------------------------------------------------------------------------
int na_tego_bec(struct wspolrzedne *ptr_wsp, float czestosc, int gen, int chr)
//w tablicy odda wsp. bitu do mutacji, w wyniku ile zmutowal, czestosc=pm, gen=w, chr=k
{
  int licznosc= gen *chr; //ilosc genow * ilosc osobnikow
  int ile,traf,w,k;

  ile= INT(czestosc*licznosc);
  //randomize();
  for(int i=0;i<ile;i++)
  {
    traf =random(licznosc);

    bool rwij=false;
    for(w=0;w<gen;w++)
    {
        for(k=0;k<chr;k++)
            {
              //k+w*chr=traf
              if (k+w*chr==traf)
                  {
                     rwij=true;
                     break;
                  }
            }//k

      if (rwij) break;
    }//w

    ptr_wsp[i].w=w;
    ptr_wsp[i].k=k;
  }

  return(ile);
}
//---------------------------------------------------------------------------

void __fastcall TFormGenetyk::ButtonOKClick(TObject *Sender)
{
ilu_osobnikow=0; //zerowanie ilosci osobnikow na poczatku proby
 const int start_pop=max_pop; //licznosc populacji startowej
 float pk=0.3; //[%] prawdopodobienstwo krzyzowania
 float pm=0.003; //[%] prawdopodobienstwo mutacji
 int ile_pk=2; //ile wylosowac punktow krzyzowanaia

 struct osobnik P[start_pop];   //deklaracja populacji P
 struct osobnik C[start_pop];   //deklaracja populacji C
 struct osobnik rodzice[2],dzieci[2]; //uzywane przy krzyzowaniu

 randomize();
 wejsc++; //ile razy startowano
 FormGenetyk->Memo->Clear(); //czysci memo
 //FormGenetyk->Progress->Max=10000;

 //utworzenie populacji poczatkowej P
 gen_populacji_start(P, max_pop);

  //ocena za pomoca funkcji dopasowania osobnikow nowej populacji P
 ocena_populacji(P, max_pop, max_gen);

 pokaz_populacje(P,0);

 while (warunek_konca(P))
 {
  pop++;
  FormGenetyk->Progress->StepIt(); //pasek stanu


  //selekcja rodzicow do krzyzowania
   int i;
  for(i=0;i<max_pop;i=i+2)
  {
   //selekcja zmodyfikowana metoda ruletki
   rodzice[0]= selekcja(P);

   int kr_sel=0;
   do    //zeby nie byl hemafrodyta ;-)
   {
     rodzice[1]= selekcja(P);
     kr_sel++;
     FormGenetyk->Edit1->Text= i2s(kr_sel);
   }
   while(rodzice[0].cargo==rodzice[1].cargo);
   //while(strcmp(rodzice[0].chromosom,rodzice[1].chromosom)==0);

   //operacja krzyzowania   pk- nieuzywane,
   do     //zeby nie bylo 0
   {
   ile_pk= random(max_pop/2);  //0-10 pk
   }
   while(ile_pk==0);

   krzyzowanie(rodzice,dzieci, pk, 3);//ile_pk);

   C[i]= dzieci[0];
   C[i+1]= dzieci[1];
  }//end i

  //mutacja w populacji C
  mutacja(C, pm, max_pop, max_gen);

 //ocena za pomoca funkcji dopasowania osobnikow nowej populacji C
 ocena_populacji(C, max_pop, max_gen);

 //populacja rodzicow P jest kasowana,a jeje miejsce zajmuje polulacja dzieci C
  for(int i=0;i<max_pop;i++)
  {
    P[i]=C[i];
    strcpy(C[i].chromosom,"");
    C[i].sila=0;
    C[i].cargo=0;
  }

  if (FormGenetyk->RG->ItemIndex==1)  //jezeli uzytkownik chce wszystkie
     pokaz_populacje(P,0);           // ok. 26 populacji przepelnia memo ;-(

 }//end while

 if (FormGenetyk->RG->ItemIndex==1 && pop>=26) //przepelnione Memo
  {
   FormGenetyk->Memo->Clear();
   FormGenetyk->Memo->Lines->Insert(0," !!! Memo PRZEPENIONE - zbyt wiele populacji aby pokazac!!!");
   pokaz_populacje(P,0);
   warunek_konca(P);
  }
 if (FormGenetyk->RG->ItemIndex==0) //jezeli pierwsza i ostatnia
         pokaz_populacje(P,0);
 FormGenetyk->Memo->Lines->Insert(0," !!! Ostatnia populacja !!!");

 pop=1;        
}
//---------------------------------------------------------------------------
